#include <iostream>
#include <NTL/ZZ.h>

NTL_CLIENT

#undef DEBUG

ZZ factorization_largest_factor(const ZZ *factor, int *expo)
{
	int j=0;

	while (expo[j])
	{
		j++;
	}
	if (j>0) return factor[j-1];
	return to_ZZ(0);
}

void factorization_print(const ZZ *factor, int *expo)
{
	int j=0;

	while (expo[j])
	{
		if (j>0) 
			cout << "*";
		cout << factor[j];
		if (expo[j]>1) 
			cout << "^" << expo[j];
		j++;
	}
	cout << endl;
}

void factorization_insert(ZZ *factor, int *expo, const ZZ &p, int e)
{
	int j=0;

#ifdef DEBUG
	cout << "factorization_insert: " << p << " " << e << endl;
#endif
	while (expo[j++]);

	j--;
	factor[j]=p;
	expo[j]=e;
	expo[j+1]=0;
}

void factorization_sort(ZZ *factor, int *expo)
{
	int i,j;
	int n;
	ZZ  tmp;
	int e_tmp;

#ifdef DEBUG
	cout << "factorization_sort" << endl;
#endif
	j=0; // how many factors
	while (expo[j++]);
	n=j-1;

	if (n<=1) return; // nothing to sort

	for (i=0;i<n;i++)
		for (j=i+1;j<n;j++)
			if (factor[j]<factor[i])
			{
				tmp=factor[j];
				factor[j]=factor[i];
				factor[i]=tmp;
				e_tmp=expo[j];
				expo[j]=expo[i];
				expo[i]=e_tmp;
			}
}

