 
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <netinet/in.h>

#define QUEUE_LEN 5
#define BUF_SIZE 100
#define MAX_STRING_LENGTH 1000
#define BUFFER_SIZE 2000
#define GET get
#define PUT put
#define GROUPEO 30

//globale Variables
FILE *file = NULL;
char *buffer = NULL;
char *fileName = "pollard.conf";
size_t buffer_size = BUFFER_SIZE;
int merker = 0;
int size = 1;
int poly;
int party = -1;

struct Bonbon
{
	char distinguishedpoint[BUFFER_SIZE];
	char expGamma[BUFFER_SIZE];
	char expBeta[BUFFER_SIZE];
};

struct Bonbon *temp, *value;


void error(char *fehler)
{
        perror(fehler);
        exit(1);
}

char* readConfiguration()
{
	size_t str_length = 0;
	buffer = (char*)malloc(buffer_size);
	int x;

	if((file = fopen(fileName, "r")) == NULL)
		error("Error opening configuration file");
	else
	{
		x = fread(buffer, 1, BUFFER_SIZE, file);
		//buffer[x] = 0;
		//printf("%s",buffer);
		
	}

	//set poly
	

	//buffer[x] = '\n';
	buffer[x] = '#';
	buffer[x+1] = 0;
	fclose(file);
	fflush(stdout);	
	return buffer;
}

void getBonbon(int sock)
{
	struct Bonbon bonbon;
	int n;
	char msg[BUFFER_SIZE];

	int i=0, more;
	

	n = recv(sock, msg, BUFFER_SIZE, 0);
	if(n == -1)
                error("Fehler beim Empfangen vom distinguishedpoint");
	else
		strcpy(bonbon.distinguishedpoint, msg);//atoi(msg);

	n = recv(sock, msg, BUFFER_SIZE, 0);
	if(n == -1)
                error("Fehler beim Empfangen vom expGamma");
	else
		strcpy(bonbon.expGamma, msg);//atoi(msg);

	n = recv(sock, msg, BUFFER_SIZE, 0);
	if(n == -1)
                error("Fehler beim Empfangen vom expBeta");
	else
		strcpy(bonbon.expBeta, msg);//atoi(msg);
	
	n = recv(sock, msg, BUFFER_SIZE, 0);
	if(n == -1)
                error("Fehler beim Empfangen vom expBeta");


// 	printf(": %d %d %d",bonbon.distinguishedpoint,bonbon.expGamma,bonbon.expBeta);
	fflush(stdout);	

	printf("%d",merker);
/*
	if(!alreadyExist(bonbon))
	{
		value[merker] = bonbon;
		merker++;
		printf("%d",value[0]);
		temp = (struct Bonbon *)malloc(size*sizeof(struct Bonbon));
		if(NULL == temp)
			error("1Kann keinen Speicher mehr reservieren!\n");
	
		printf("%d",value[0]);
		fflush(stdout);	
		for(i=0; i<size; i++) 
		{
			temp[i]=value[i];
		}
		size++;
		value = (struct Bonbon *)malloc(size * sizeof(struct Bonbon));
		if(NULL == value)
			error("2Kann keinen Speicher mehr reservieren!\n");
		for(i=0; i<size; i++)
			value[i]=temp[i];
		printf("%i", value[1]);
		/*for(i=0; i<size; i++)
		{
			struct Bonbon tmp = (struct Bonbon)value[i];
			char dp[BUFFER_SIZE] = tmp.distinguishedpoint;
			char expa[BUFFER_SIZE] = tmp.expGamma;
			char expb[BUFFER_SIZE] = tmp.expBeta;
			printf("An der Stelle %d ist der distinguishedpoint %s, expGamma %s, expBeta %s\n" , i, dp, expa, expb);
		}
	}*/
}

int alreadyExist(struct Bonbon bonbon)
{
	int bAlreadyExist = 0;
	int i;
	struct Bonbon tmp;
	for(i=0; i<size; i++)
	{
		tmp = (struct Bonbon)value[i];
		//strcpy(tmp,(struct Bonbon)value[i]);
		if(strcmp(tmp.distinguishedpoint, bonbon.distinguishedpoint) == 0 &&
		   strcmp(tmp.expBeta, bonbon.expBeta) != 0)
		{
			printf("Success");
			bAlreadyExist = 1;
			break;
		}
	}
	if(bAlreadyExist)
		party = (((atoi(bonbon.expGamma) - atoi(tmp.expGamma)) / (atoi(tmp.expBeta) - atoi(bonbon.expBeta)))) % (2^GROUPEO -1);
	
	return bAlreadyExist;
}

int handleConnection(int sock, int childNum)
{
	int n;
        char msg[BUFFER_SIZE];

	n = recv(sock, msg, BUFFER_SIZE, 0);//n= Anzahl
        if(n == -1)
                error("Fehler beim Empfangen");

	msg[3]=0;
	//printf("Msg: '%s'\n",msg);
	//printf("Get: %d\n",strcmp(msg, "GET"));
	//printf("Put: %d\n",strcmp(msg, "PUT"));
	if (strcmp(msg, "GET") == 0)
	{
		if(send(sock, readConfiguration(), BUFFER_SIZE, 0) == -1)
                	error("Fehler beim Senden vom GET");
	}
	else if (strcmp(msg, "PUT") == 0)
		getBonbon(sock);
	else
		printf("Message not handled.");
}

int main(int argc, char **argv)
{
	//array
	//size = 1;
	value = (struct Bonbon *)malloc(1*sizeof(struct Bonbon));
	if(NULL == value)
      		error("Fehler bei malloc...!! n");

	//socket

	int listenSock;
        int retCode;
        struct sockaddr_in serverAddr;
        struct sockaddr_in clientAddr;
        int clientAddrSize;
        int port = 2345;
        int dataSock;
        pid_t childPid;
        int childNum;
        int optval;

        //Socket erzeugen
        listenSock = socket(AF_INET, SOCK_STREAM, 0);
        if (listenSock == -1)
                error("Server kann Socket nicht erzeugen");

        //Socket-Option einstellen
        optval = 1;
        retCode = setsockopt(listenSock, SOL_SOCKET, SO_REUSEADDR, (void *) &optval, sizeof(optval));
        if (retCode == -1)
                error("setsockopt() gescheitert");

	//Socket mit "Namen", d.h. mit Port verbinden */
        memset((void *) &serverAddr, 0, sizeof(serverAddr));
        serverAddr.sin_family = AF_INET;
        serverAddr.sin_addr.s_addr = htonl(INADDR_ANY);
        serverAddr.sin_port = htons(port);
        retCode = bind(listenSock, (struct sockaddr *) &serverAddr, sizeof(serverAddr));
        if (retCode == -1)
                error("Server kann Port nicht binden");


        //Socket fuer eingehende Verbindungen aktivieren
        retCode = listen(listenSock, QUEUE_LEN);
        if (retCode == -1)
                error("Server kann nicht an Socket horchen");

	//Warten auf Verbindungen(Vaterprozess endlos)
        childNum = 0;
	
        while(party == -1)
        {
                //Verbindung annehmen
                clientAddrSize = sizeof(clientAddr);
                dataSock = accept(listenSock, (struct sockaddr *) &clientAddr, &clientAddrSize);

                if (dataSock == -1)
                        error("interner Fehler: accept() ging schief");

		handleConnection(dataSock, childNum);
		close(dataSock);
        }
	printf("Result: %d \n", party);
	return 0;
}


