//
// $Id: trialdiv_functions.c,v 1.2 2007/03/24 13:27:00 dw Exp $
//
// Sat Apr 28 21:54:23 UTC 2001
//
// 
// 
//
#include <NTL/ZZ.h>

NTL_CLIENT

#include "factoring.h"


int trialdiv_ub(ZZ &n, long B, ZZ *factor, int *expo)
{
	int rc;
	unsigned long *prime;

	expo[0]=0; /* init factorization */

	prime=erathostenes(B);
	rc=trialdiv(n,prime,factor,expo);
	free(prime);

	return rc;
}


int trialdiv(ZZ &n, unsigned long *prime, ZZ *factor, int *expo)
{
	register int k;
	int rc=0; /* factorization not complete */
	int e; /* current exponent */
	int n_is_prime=0;

	expo[0]=0; /* init factorization */
	if (n<0)
		n=-n;
	if (ProbPrime(n,7))
	{
		factorization_insert(factor,expo,n,1);
		return 1;
	}

	k=0;

	while (prime[k]) 
	{
		e=0;
		while (n%prime[k]==0)
		{
			e++;
			n/=prime[k];
		}
		if (e) factorization_insert(factor,expo,to_ZZ(prime[k]),e);
		if (n==1) return 1;
		if (ProbPrime(n)) 
		{
			n_is_prime=1;
			break;
		}
		k++;
	}

	if (n>1)
	{
		if (n_is_prime) 
		{
			rc=1;
			factorization_insert(factor,expo,n,1);
			n=1;
		}
	}

	return rc; 
}


